> Documentation index for AI agents: https://docs.pagerduty.com/llms.txt

# Create custom shifts

`POST https://api.pagerduty.com/v3/schedules/{id}/custom_shifts`

<!-- theme: info -->

> **Important note:** Shift-based schedules use the V3 API and are not compatible with V2 automations. **To create automations for Shift-Based Schedules, you need to:**
>
> 1. **Update your automations** to use the V3 API for all new shift-based schedules
> 2. **Keep the V2 endpoint** for your existing schedules
>
> An upgrade tool for existing schedules is coming soon; your legacy schedules will keep working in the meantime. [Learn more](https://support.pagerduty.com/main/docs/shift-based-schedules-api-upgrade-examples).

Create one or more custom shifts for a schedule. Custom shifts are
ad-hoc one-off coverage periods that exist outside of rotation events.

Each custom shift requires exactly one assignment.

## Authorization

- **api_key** (apiKey) — `Authorization` header. The API Key with format `Token token=<API_KEY>`

## Path parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `id` | string | yes | The ID of the schedule. |

## Request body (`application/json`) — required

| Field | Type | Required | Description |
|---|---|---|---|
| `custom_shifts` | array of object | yes | Min items: 1. |
| `custom_shifts[].type` | string | yes | One of: `custom_shift`. |
| `custom_shifts[].start_time` | string (date-time) | yes |  |
| `custom_shifts[].end_time` | string (date-time) | yes |  |
| `custom_shifts[].assignments` | array of object | yes | Min items: 1. Max items: 1. |
| `custom_shifts[].assignments[].type` | string | yes | One of: `shift_assignment`. |
| `custom_shifts[].assignments[].member` | object | yes | A member (user) assigned to a shift or rotation slot. |
| `custom_shifts[].assignments[].member.type` | string | yes | `user_member` — a specific user is assigned. `empty_member` — the slot is intentionally unassigned. One of: `user_member`, `empty_member`. |
| `custom_shifts[].assignments[].member.user_id` | string |  | The ID of the user. Required when type is `user_member`. |

Example: default

```json
{
  "custom_shifts": [
    {
      "type": "custom_shift",
      "start_time": "2025-03-15T09:00:00Z",
      "end_time": "2025-03-15T17:00:00Z",
      "assignments": [
        {
          "type": "shift_assignment",
          "member": {
            "type": "user_member",
            "user_id": "PUSER123"
          }
        }
      ]
    }
  ]
}
```

## Response 201

Custom shifts created successfully

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `custom_shifts` | array of object | yes |  |
| `custom_shifts[].id` | string | yes |  |
| `custom_shifts[].type` | string | yes | One of: `custom_shift`. |
| `custom_shifts[].start_time` | string (date-time) | yes |  |
| `custom_shifts[].end_time` | string (date-time) | yes |  |
| `custom_shifts[].assignments` | array of object | yes | Exactly one assignment per custom shift. Min items: 1. Max items: 1. |
| `custom_shifts[].assignments[].id` | string | yes | Assignment ID. |
| `custom_shifts[].assignments[].type` | string | yes | One of: `shift_assignment`. |
| `custom_shifts[].assignments[].member` | object | yes | A member (user) assigned to a shift or rotation slot. Same fields as `custom_shifts[].assignments[].member` above. |
| `custom_shifts[].self` | string (uri) |  |  |
| `custom_shifts[].html_url` | string (uri) |  |  |

## Response 400

Bad Request — The request contains invalid parameters or data

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object | yes |  |
| `error.message` | string | yes |  |
| `error.code` | integer | yes |  |
| `error.errors` | object |  | Map of field path to list of validation messages for that field. Field paths use dot notation prefixed by the resource type (e.g. `event.effective_since`, `rotation.events`). |

Example: default

```json
{
  "error": {
    "message": "Invalid Request",
    "code": 2001,
    "errors": {
      "event.effective_since": [
        "Date cannot be more than 12 months in the future"
      ]
    }
  }
}
```

## Response 401

Caller did not supply credentials or did not provide the correct credentials.
If you are using an API key, it may be invalid or your Authorization header may be malformed.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 403

Caller is not authorized to view the requested resource.
While your authentication is valid, the authenticated user or token does not have permission to perform this action.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 404

The requested resource was not found.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 500

Internal Server Error the PagerDuty server experienced an error.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Developer Agreement

Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement).
